;*************************************************************************
; Copyright (c) 2002 The University of Chicago, as Operator of Argonne
; National Laboratory.
; Copyright (c) 2002 The Regents of the University of California, as
; Operator of Los Alamos National Laboratory.
; This file is distributed subject to a Software License Agreement found
; in the file LICENSE that is included with this distribution. 
;*************************************************************************

FUNCTION FILE_CHECK, fileName

  OPENR, lun, fileName, /Get_LUN, Error = err

  IF(err EQ 0) THEN BEGIN
      Free_LUN, lun
      RETURN, 1
  ENDIF ELSE   $
      RETURN, 0

END


PRO xxBackground_event, Event
  
  COMMON CATCH_IMAGE, widget_ids, imageData
  COMMON BK_COMMON, bkImage, bkDrawId

  WIDGET_CONTROL,Event.Id,GET_UVALUE=Ev

  print, Ev

  CASE Ev of
  'open': BEGIN
            F=PICKFILE(/READ, GET_PATH=P, FILTER = '*.idlImage')
            IF F eq '' THEN return
            IF (STRMID(F,0,1) EQ '/') THEN $
                FNAME = F $
            ELSE $
                FNAME = P+F

            Print, FNAME

            IF (FILE_CHECK(FNAME) EQ 0) THEN BEGIN
                response = WIDGET_MESSAGE('File does not exist !')
                RETURN
            ENDIF

            RESTORE, FNAME
            bkImage = saveImage
            tPlot = REBIN(bkImage,256,240)
            WSET, bkDrawId
            TV, tPlot
            XYOUTS, 4, 4, FNAME, /DEVICE, COLOR = 255

          END

  'save': BEGIN
            F=PICKFILE(/WRITE, GET_PATH=P, FILTER = '*.idlImage')
            IF F eq '' THEN return

            IF (STRMID(F,STRLEN(F)-9, 9) NE '.idlImage') THEN $
                F = F + '.idlImage'

            IF (STRMID(F,0,1) EQ '/') THEN $
                FNAME = F $
            ELSE $
                FNAME = P+F

            IF (FILE_CHECK(FNAME) EQ 1) THEN BEGIN
              response = WIDGET_MESSAGE('Overwrite existing file ?', /QUESTION)
              IF (response EQ 'No') THEN RETURN
            ENDIF

            saveImage = bkImage
            OPENW, lun, FNAME, /Get_LUN, Error = err
            IF (err NE 0)  THEN BEGIN
                result = WIDGET_MESSAGE("FILE WRITE ERROR !")
            ENDIF ELSE BEGIN
                Free_LUN, lun
                save, saveImage, filename=FNAME
            ENDELSE

          END

  'readBkBUTTON': BEGIN
            IF (STRLEN(imageData.imagePV) EQ 0) THEN BEGIN
              outString = 'No Image System Selected'
              WSET, bkDrawId
              XYOUTS, 4, 100, outString, /DEVICE, COLOR = 255, SIZE = 1.5
              RETURN
            ENDIF
            status = caPut(imageData.imagePV + 'ReadBkgndSU.PROC', 0)
            WAIT, 1.00
            bkPvs=STRARR(480)
            FOR i=0, 479 DO bkPvs[479-i]=imageData.imagePV + 'Bkgnd.L'+  $
                            STRTRIM(STRING(i+1),2)
            status = caGetArray(bkPvs, tempImage, max=512, type=1)
            bkImage = FIX(tempImage)
            tPlot = REBIN(bkImage,256,240)
            WSET, bkDrawId
            TV, tPlot
            XYOUTS, 4, 4, imageData.imagePV + 'Bkgnd', /DEVICE, COLOR = 255
          END

  'writeBkBUTTON': BEGIN
            IF (STRLEN(imageData.imagePV) EQ 0) THEN BEGIN
              outString = 'No Image System Selected'
              WSET, bkDrawId
              XYOUTS, 4, 100, outString, /DEVICE, COLOR = 255, SIZE = 1.5
              RETURN
            ENDIF
            bkPvs=STRARR(480)
            FOR i=0, 479 DO bkPvs[479-i]=imageData.imagePV + 'Bkgnd.L'+  $
                            STRTRIM(STRING(i+1),2)
            tempImage = BYTE(bkImage)
            status = caPutArray(bkPvs, tempImage)
            WAIT, .25
            status = caPut(imageData.imagePV + 'WriteBkgndSU.PROC', 0)
          END

  'exit': BEGIN
              WIDGET_CONTROL, event.top, /DESTROY
          END
  ENDCASE
END

PRO xxBackground

  COMMON CATCH_IMAGE, widget_ids, imageData

  version = '1.1'
  device, pseudo=8
    
  tlb = WIDGET_BASE( $
      COLUMN=1, $
      MAP=1, $
      TITLE='Image Background  (' + version + ')', $
      MBAR = menubar)

  fileMenu = WIDGET_BUTTON(menubar, $
      VALUE = 'File')

  OpenMenuBut = WIDGET_BUTTON(fileMenu, $
      VALUE = 'Open', $
      UVALUE = 'open')

  SaveMenuBut = WIDGET_BUTTON(fileMenu, $
      VALUE = 'Save', $
      UVALUE = 'save')

  exitMenBut = WIDGET_BUTTON(fileMenu, $
      VALUE = 'Exit', $
      UVALUE = 'exit', $
      /SEPARATOR)

  base_1 = WIDGET_BASE(tlb, $
      COLUMN=1, $
      XSIZE=250, $
      MAP=1, $
      TITLE='Buttons', $
      UVALUE='base_1')

  label_1 = WIDGET_LABEL( base_1, $
      ALIGN_CENTER = 1, $
      VALUE='MV20/MV200 Background Image')

  base_2 = WIDGET_BASE(base_1, $
      ROW=1, $
      ALIGN_CENTER = 1, $
      FRAME=2, $
      MAP=1, $
      TITLE='Buttons', $
      UVALUE='base_1')

  readBkBut = WIDGET_BUTTON( base_2, $
      UVALUE='readBkBUTTON', $
      VALUE='Read from IOC')

  writeBkBut = WIDGET_BUTTON( base_2, $
      UVALUE='writeBkBUTTON', $
      VALUE='Write to IOC')

  bkDrawArea = WIDGET_DRAW( tlb, $
      BUTTON_EVENTS=1, $
      RETAIN=2, $
      UVALUE='DRAW', $
      XSIZE=256, $
      YSIZE=240)

  WIDGET_CONTROL, tlb, /REALIZE

  COMMON BK_COMMON, bkImage, bkDrawId
  WIDGET_CONTROL, bkDrawArea, GET_VALUE=bkDrawId
  bkImage = INTARR(512, 480)

  XMANAGER, 'xxBackground', tlb

END
    
